"use strict";var __awaiter=this&&this.__awaiter||function(e,r,t,i){return new(t||(t=Promise))(function(s,n){function o(e){try{u(i.next(e))}catch(e){n(e)}}function a(e){try{u(i.throw(e))}catch(e){n(e)}}function u(e){e.done?s(e.value):new t(function(r){r(e.value)}).then(o,a)}u((i=i.apply(e,r||[])).next())})};Object.defineProperty(exports,"__esModule",{value:!0});const _=require("lodash"),appError_1=require("./appError"),platform_1=require("./modules/platform"),qlogger_1=require("./modules/qlogger"),config_1=require("./modules/data/config"),printerServerClientManger_1=require("./modules/communication/printerServerClientManger"),printerRequestHelper_1=require("./printerRequestHelper");class PrinterManagement{constructor(e,r,t,i){this.autoRegistration=!0,this.onSubscribed=((e,r)=>__awaiter(this,void 0,void 0,function*(){if("NotifyPrinters"===e){const e=r,t=!!e.isLocalServer&&this.autoRegistration,i=yield this.updatePrinterList([e],t);i.err?qlogger_1.default.error(`onPrinterList: "${i.err.message}" ${JSON.stringify(i.err)} ${JSON.stringify(e)} ${t}`):yield this.updateConnection()}})),this.db=e,this.printer=r,this.printerModel=t,this.printerStatus=i,this.printer.on(printerServerClientManger_1.default.Events.Subscribed,this.onSubscribed)}dispose(){this.printer.removeListener(printerServerClientManger_1.default.Events.Subscribed,this.onSubscribed)}startAutoRegistration(){this.autoRegistration=!0,setTimeout(()=>this.autoRegistration=!1,PrinterManagement.AutoRegistrationLimit);const e={request:101,timeout:PrinterManagement.RequestOnlyTimeout};this.printer.sendRequest(e)}getPrinters(e,r){return __awaiter(this,void 0,void 0,function*(){const t=(yield this.db.getPrinters()).filter(r=>!e||r.serial===e).map(e=>{const t=(e=>{const t={localhost:r&&void 0!==r.localhost?r.localhost&&e.isLocal:e.isLocal};return this.printerModel.getAppInfo(e.model,t)})(e),i=(e=>{const r=this.printerStatus.getStatus(e.serial);if(r.err||0===r.statuses.length)return;const t=r.statuses.filter(e=>e.queues);if(0!==t.length)return t.map(e=>e.queues).reduce((e,r)=>(e.push(...r),e)).sort()})(e);return _.merge({},e,{appInfo:t,queues:i})});return Promise.resolve(t)})}getModels(){return __awaiter(this,void 0,void 0,function*(){const e=yield this.getPrinters(),r=_.sortedUniqBy(_.sortBy(e,"model"),"model").map(e=>{return{model:e.model,appInfo:e.appInfo}});return Promise.resolve(r)})}getAppInfoBySerial(e){return this.printerModel.getAppInfoBySerial(e)}getRegistration(){return __awaiter(this,void 0,void 0,function*(){const e={printers:yield this.db.getRegistrationPrinters(),searchOptions:yield this.db.getSearchOptions(),isEnablePcSearch:config_1.default.getInst().settings.remoteConnection,isEnablePrinterSearch:!platform_1.default.isWin,upperLimit:{printerRegistration:config_1.default.getInst().settings.registration.printer,searchIpAddress:config_1.default.getInst().settings.registration.ipAddress}};return e.printers.map(e=>{const r=this.printerModel.getAppInfo(e.model.name);return _.merge(e,{appInfo:r})}),Promise.resolve(e)})}setPrinterRegistration(e){return __awaiter(this,void 0,void 0,function*(){const r=yield this.db.setPrinterRegistration(e);return r.err?qlogger_1.default.error(`setPrinterRegistration: "${r.err.message}" ${JSON.stringify(r.err)} ${JSON.stringify(e)}`):yield this.updateConnection(),Promise.resolve(r)})}setSearchIpAddress(e,r){return __awaiter(this,void 0,void 0,function*(){const t=yield this.db.setSearchDevice(e,r);return t.err&&qlogger_1.default.error(`setSearchIpAddress: "${t.err.message}" ${JSON.stringify(t.err)} ${JSON.stringify(e)} ${r}`),Promise.resolve({err:t.err,id:t.id})})}search(e,r,t){return __awaiter(this,void 0,void 0,function*(){this.autoRegistration=!1;const i={id:t?t.id:void 0,request:e,params:{searchOptions:r},timeout:t?t.timeout:void 0};switch(e){case 106:return this.addSearch(i);case 107:return this.refreshSearch(i);default:return Promise.resolve({err:new appError_1.default(1002,`request: '${e}'`)})}})}checkPrinterServerConnection(e,r,t){return 1===r?Promise.resolve({err:new appError_1.default(2e3)}):this.printer.checkConnection(e,3===r,t?t.timeout:void 0)}checkPrinterConnection(e,r,t){return __awaiter(this,void 0,void 0,function*(){if(1===r)return Promise.resolve({err:new appError_1.default(2e3)});const i={request:108,params:{ipAddress:e,type:r},timeout:t?t.timeout:void 0},s=yield this.printer.sendRequest(i);return Promise.resolve(s)})}updateLocalServerPrinters(e,r){return __awaiter(this,void 0,void 0,function*(){const t={id:r?r.id:void 0,request:e,params:{searchOptions:{pcIpAddresses:[]}},timeout:r?r.timeout:void 0};return this.printer.sendRequestLocal(t)})}setPrinterFriendlyName(e,r,t,i){return __awaiter(this,void 0,void 0,function*(){const s=printerRequestHelper_1.default.select(e,i,this.printerStatus);if(s.err)return Promise.resolve({err:new appError_1.default(s.err)});const n={id:i?i.id:void 0,request:117,params:{friendlyName:r},printerServer:s.printerServer,printer:s.printer,timeout:i?i.timeout:void 0},o=yield this.printer.sendRequest(n);if(!o.err){const i=[{serial:e,nickname:r,isRegistered:t}];yield this.setPrinterRegistration(i)}return Promise.resolve(o)})}updateConnection(){return __awaiter(this,void 0,void 0,function*(){const e=yield this.db.getConnectionStructure();this.printer.updateConnection(e),this.printerStatus.updateRegistration(e)})}addSearch(e){return __awaiter(this,void 0,void 0,function*(){const r=yield this.printer.sendRequest(e);if(r.err)return qlogger_1.default.error(`search: "${r.err.message}" ${JSON.stringify(r.err)} ${JSON.stringify(e)}`),Promise.resolve(r);const t=yield this.updatePrinterList(r.printerServers,!1);return t.err?(qlogger_1.default.error(`search: "${t.err.message}" ${JSON.stringify(t.err)} ${JSON.stringify(e)}`),Promise.resolve(t)):Promise.resolve(r)})}refreshSearch(e){return __awaiter(this,void 0,void 0,function*(){if(!platform_1.default.isWin){const r=e.params.searchOptions.printerIpAddresses,t=(yield this.db.getRegistrationPrinters()).filter(e=>e.isRegistered&&e.isLocal);for(const e of t)r.find(r=>r.ipAddress===e.interface.ipAddress)||r.push(e.interface)}const r=yield this.printer.sendRequest(e);if(r.err)return qlogger_1.default.error(`search: "${r.err.message}" ${JSON.stringify(r.err)} ${JSON.stringify(e)}`),Promise.resolve(r);const t=yield this.renewPrinterList(r.printerServers);return t.err?(qlogger_1.default.error(`search: "${t.err.message}" ${JSON.stringify(t.err)} ${JSON.stringify(e)}`),Promise.resolve(t)):(yield this.updateConnection(),Promise.resolve(r))})}updatePrinterList(e,r){return __awaiter(this,void 0,void 0,function*(){let t={};for(const i of e)if(this.removeUnsupportPrinters(i),(t=yield this.db.setConnectionStructure(i,r)).err)break;return Promise.resolve(t)})}renewPrinterList(e){return this.removeUnsupportPrinters(...e),this.db.renewPrinterList(e)}removeUnsupportPrinters(...e){for(const r of e)_.remove(r.printers,e=>!this.printerModel.isSupportPlatform(e.model.name)||!this.printerModel.isSupportModel(e.model.name))}}PrinterManagement.AutoRegistrationLimit=18e4,PrinterManagement.RequestOnlyTimeout=5e3,exports.default=PrinterManagement;